//
//  YHOneKeyLoginViewModel.swift
//  galaxy
//
//  Created by edy on 2024/5/30.
//  Copyright © 2024 https://www.galaxy-immi.com. All rights reserved.
//

import UIKit

class YHOneKeyLoginViewModel {
    
    func getSecretKeyInfo(completion:((String) -> ())?) {
        
        let strUrl = YHBaseUrlManager.shared.curURL() + YHAllApiName.Auth.oneKeySecretKeyInfo
        let params = ["iosInfo.bundleId" : "com.intelligence.galaxy"]
        let _ = YHNetRequest.getRequest(url: strUrl, params: params) { 
            json, code in
            printLog("model 是 ==> \(json)")
            if json.code == 200 {
                if let dic = json.data as? [String: Any], let sdkKey = dic["sdkKey"] as? String, !sdkKey.isEmpty {
                    completion?(sdkKey)
                    
                } else {
                    completion?("")
                }
                
            } else {
                completion?("")
            }
            
        } failBlock: { error in
            completion?("")
        }
    }
    
    func oneKeyLogin(authToken: String, callBackBlock: @escaping (_ success: Bool,_ error: YHErrorModel?)->()) {
        
        let params: [String : Any] = ["auth_token": authToken]
        let strUrl = YHBaseUrlManager.shared.curURL() + YHAllApiName.Auth.oneKeyLogin
        let _ = YHNetRequest.postRequest(url: strUrl, params: params) {
            
            json, code in
            printLog(json)
            let dic = json.data
            guard let resultModel = YHUserModel.deserialize(dict: dic as? [AnyHashable : Any]) else {
                let error : YHErrorModel = YHErrorModel(errorCode:-1,errorMsg: "数据解析不成功")
                callBackBlock(false, error)
                return
            }
            
            if json.code == 200 {
                if resultModel.token?.count != 0 {
                    //token 正常
                    YHLoginManager.shared.userModel = resultModel
                    //数据保存到本地
                    YHLoginManager.shared.saveLocalUserInfo()
                    
                    NotificationCenter.default.post(name: YhConstant.YhNotification.didLoginSuccessNotifiction, object: nil)
                    
                    //回调
                    callBackBlock(true,nil)
                } else {
                    let error : YHErrorModel = YHErrorModel(errorCode:-2,errorMsg: "token 不合法")
                    callBackBlock(false,error)
                }
            } else {
                let error : YHErrorModel = YHErrorModel(errorCode:Int32(json.code), errorMsg: json.msg)
                callBackBlock(false,error)
            }
        } failBlock: { err in
            callBackBlock(false, err)
        }
    }
    

}
